<?php
require_once('base.php');

class Image extends Base
{
	function __construct()
	{
		parent::__construct();
		$this->key = true;
		$this->auth = false;
	}

	function OnInput()
	{
		parent::oninput();
		list($zero, $image, $base) = explode('/', $_SERVER['REQUEST_URI'], 3);
		
		if ($image != 'image')
		{
			$this->View('404', array('T' => mTemp::instance()));
			return null;
		}

		$url = file_get_contents(base64_decode($base));
		$now = strftime('D, d M Y H:i:s', time());
		$expire = strftime('D, d M Y H:i:s', time() + 2592000);
		header('Cache-Control: private, max-age=2592000');
		header('Pragma: private');
		header('Last-Modified: ' . $now . ' GMT');
		header('Expires: ' . $expire . ' GMT');

		if (isset($_SERVER['HTTP_IF_MODIFIED_SINCE']))
		{
			header('Last-Modified: ' . $_SERVER['HTTP_IF_MODIFIED_SINCE'], true, 304);
			exit();
		}

		$extensions = array('json', 'php', 'txt', 'ini', 'key');
		$extension = pathinfo(base64_decode($base), PATHINFO_EXTENSION);

		if (in_array($extension, $extensions))
		{
			exit();
		}

		switch ($extension)
		{
			case 'jpg':
				$type = 'image/jpeg';
				break;
			case 'gif':
				$type = 'image/gif';
				break;
			case 'png':
				$type = 'image/png';
				break;
			default:
				$type = 'image/jpeg';
				break;
		}

		header('Content-Type: ' . $type);
		echo($url);
		exit();
	}

	function OnOutput()
	{
	
	}
}
?>