<?php
class mTemp
{
	protected $F = null;
	
	protected $query = null;
	
	protected $host = null;
	
	protected $template = null;
	
	var $elements = null;

	function Instance($query = '', $elements = '', $template = '')
	{
		if (is_null($instance))
		{
			$instance = new mTemp($query, $elements, $template);
		}
		
		return $instance;
	}

	function __construct($query = '', $elements = '', $template = '')
	{
		$this->F = mFunc::instance();
		$this->query = $query;
		$this->host = $this->F->host;
		$this->elements = $elements;
		$this->template = !empty($template) ? $template : $this->F->config['TEMPLATE'];
	}

	function __clone()
	{
	
	}

	function Title()
	{
		$controller = $this->F->GetController($_SERVER['REQUEST_URI']);

		if (empty($controller) || empty($this->query))
		{
			$title = $this->F->config['TITLE'];
		}
		else
		{
			$title = mb_strtoupper(mb_substr($this->query, 0, 1, 'UTF-8'), 'UTF-8') . mb_substr($this->query, 1, strlen($this->query), 'UTF-8') . (' - ' . $this->F->config['TITLE']);
		}

		return $title;
	}

	function Base()
	{
		echo '<base href="' . $this->host . '">
		';
	}

	function Description()
	{
		if (!empty($this->elements['snippets']))
		{
			$content = htmlentities($this->elements['snippets'][0]['description'] . ' - ' . $this->elements['snippets'][0]['title'], ENT_QUOTES, 'UTF-8');
			echo '<meta name="description" content="' . $content . '">' . "\r\n";
		}
	}

	function Keywords()
	{
		if (!empty($this->query))
		{
			$content = implode(', ', explode(' ', $this->query));
			echo '<meta name="keywords" content="' . $content . '">' . "\r\n";
		}

	}

	function ICO($file)
	{
		echo '<link type="image/x-icon" rel="shortcut icon" href="' . $this->host . '/templates/' . $this->template . '/' . $file . '">'. "\r\n";
	}

	function CSS($file)
	{
		echo '<link type="text/css" rel="stylesheet" href="' . $this->host . '/templates/' . $this->template . '/css/' . $file . '">' . "\r\n";
	}

	function JS($file)
	{
		echo '<script type="text/javascript" src="' . $this->host . '/templates/' . $this->template . '/js/' . $file . '"></script>' . "\r\n";
	}

	function RSS()
	{
		$title = $this->Title();
		$controller = $this->F->GetController($_SERVER['REQUEST_URI']);

		if (empty($controller))
		{
			$href = $this->F->CreateUrl('rss/');
		}
		else
		{
			$href = $this->F->CreateUrl('rss/' . $this->query);
		}

		echo '<link type="application/rss+xml" rel="alternate" href="' . $href . '" title="' . $title . '">' . "\r\n";
	}

	function IMG($file)
	{
		echo $this->host . '/templates/' . $this->template . '/img/' . $file;
	}

	function Query($type)
	{
		$query = '';
		switch ($type)
		{
			case 'base':
				$query = $this->F->GetKeyword();
				break;
			case 'cache':
				$query = $this->F->Query();
				break;
			case 'current':
				$query = $this->query;
				break;
		}

		return $query;
	}

	function Queries($count, $route = '', $tag = '', $id = '', $class = '')
	{
		$queries = $this->F->GetQueries($count);
		if (!empty($queries))
		{
			$controller = !empty($route) ? $route : $this->F->config['ROUTE'];
			$id = !empty($id) ? ' id="' . $id . '"' : '';
			$class = !empty($class) ? ' class="' . $class . '"' : '';
			foreach ($queries as $query)
			{
				$url = $this->F->CreateUrl($controller . '/' . $query);
				$query = ucfirst(mb_substr($query, 0, 1, 'UTF-8')) . mb_substr($query, 1, strlen($query), 'UTF-8');

				if (!empty($tag))
				{
					echo '<' . $tag . $id . $class . '><a href="' . $url . '">' . $query . '</a></' . $tag . '>' . "\r\n";
					continue;
				}

				echo '<a' . $id . $class . ' href="' . $url . '">' . $query . '</a>' . "\r\n";
			}
		}
	}

	function Snippet($key, $tag = '', $id = '', $class = '')
	{
		$object = new stdClass();

		if (isset($this->elements['snippets']) && isset($this->elements['snippets'][$key]))
		{
			$snippet = $this->elements['snippets'][$key];
			$id = !empty($id) ? ' id="' . $id . '"' : '';
			$class = !empty($class) ? ' class="' . $class . '"' : '';
			$url = $this->Url('url');

			if (!empty($tag))
			{
				if (!empty($snippet['link']))
				{
					$object->title = '<' . $tag . $id . $class . '>' . $snippet['link'] . '</' . $tag . '>' . "\r\n";
				}
				else
				{
					$object->title = '<' . $tag . $id . $class . '><a href="' . $url . '" title="' . $snippet['title'] . '">' . $snippet['title'] . '</a></' . $tag . '>' . "\r\n";
				}
				
				$object->description = '<' . $tag . $id . $class . '>' . $snippet['description'] . '</' . $tag . '>' . "\r\n";
			}
			else
			{
				if (!empty($snippet['link']))
				{
					$object->title = $snippet['link'];
				}
				else
				{
					$object->title = '<a href="' . $url . '" title="' . $snippet['title'] . '">' . $snippet['title'] . '</a>';
				}

				$object->title = $snippet['title'];
				$object->description = $snippet['description'];
			}
		}
		else
		{
			$object->link = '';
			$object->title = '';
			$object->description = '';
		}

		return $object;
	}

	function Image($key, $tag = '', $id = '', $class = '', $width = '', $height = '')
	{
		$object = new stdClass();

		if (isset($this->elements['images']) && isset($this->elements['images'][$key]))
		{
			$image = $this->elements['images'][$key];
			$id = !empty($id) ? ' id="' . $id . '"' : '';
			$class = !empty($class) ? ' class="' . $class . '"' : '';
			$_width = $width;
			$_height = $height;
			$width = !empty($width) ? ' width="' . $width . '"' : '';
			$height = !empty($height) ? ' height="' . $height . '"' : '';
			$small = trim($image['small']);
			$object->srcs = $this->host . '/image/' . $small;
			$large = trim($image['large']);
			$object->srcl = $this->host . '/image/' . $large;

			if (!empty($tag))
			{
				$object->title = '<' . $tag . $id . $class . '>' . $image['title'] . '</' . $tag . '>';
				$object->small = "<div style=\"width: {$_width}px; height: {$_height}px; float: left; margin: 1px; padding: 1px;\"><" . $tag . $id . $class . '><img src="' . $this->host . '/image/' . base64_encode($small) .
									'" alt="' . $image['title'] . '" title="' . $image['title'] . '"' . $width . $height . '></' . $tag . '></div>';
				$object->large = '<' . $tag . $id . $class . '><img src="' . $this->host . '/image/' . base64_encode($large) . '" alt="' . $image['title'] . '" title="' . $image['title'] . '"' . $width . $height . '></' . $tag . '>';
			}
			else
			{
				$object->title = $image['title'];
				$object->small = '<img src="' . $this->host . '/image/' . base64_encode($small) . '" alt="' . $image['title'] . '" title="' . $image['title'] . '"' . $width . $height . '>';
				$object->large = '<img src="' . $this->host . '/image/' . base64_encode($large) . '" alt="' . $image['title'] . '" title="' . $image['title'] . '"' . $width . $height . '>';
			}
		}
		else
		{
			$object->srcs = '';
			$object->srcl = '';
			$object->title = '';
			$object->small = '';
			$object->large = '';
		}

		return $object;
	}

	function Video($key, $tag = '', $id = '', $class = '', $width = '', $height = '')
	{
		$object = new stdClass();

		if (isset($this->elements['videos']) && isset($this->elements['videos'][$key]))
		{
			$video = $this->elements['videos'][$key];
			$url = trim($video['src']);
			$id = !empty($id) ? ' id="' . $id . '"' : '';
			$class = !empty($class) ? ' class="' . $class . '"' : '';
			$width = !empty($width) ? ' width="' . $width . '"' : '';
			$height = !empty($height) ? ' height="' . $height . '"' : '';
			$object->src = $this->host . '/image/' . $url;
			$object->url = $video['url'];

			if (!empty($tag))
			{
				$object->title = '<' . $tag . $id . $class . '>' . $video['title'] . '</' . $tag . '>';
				$object->image = '<' . $tag . $id . $class . '><img src="' . $this->host . '/image/' . $url . '" alt="' . $video['title'] . '" title="' . $video['title'] . '"' . $width . $height . '></' . $tag . '>';
				$object->iframe = '<' . $tag . $id . $class . '><iframe src="' . $video['url'] . '"' . $width . $height . ' frameborder="0"></iframe></' . $tag . '>';
			}
			else
			{
				$object->title = $video['title'];
				$object->image = '<img src="' . $this->host . '/image/' . $url . '" alt="' . $video['title'] . '" title="' . $video['title'] . '"' . $width . $height . '>';
				$object->iframe = '<iframe src="' . $video['url'] . '"' . $width . $height . '></iframe>';
			}
		}
		else
		{
			$object->src = '';
			$object->url = '';
			$object->title = '';
			$object->image = '';
			$object->iframe = '';
		}

		return $object;
	}

	function Comment($key, $tag = '', $id = '', $class = '')
	{
		$object = new stdClass();

		if (isset($this->elements['comments']) && isset($this->elements['comments'][$key]))
		{
			$comment = $this->elements['comments'][$key];
			$url = trim($comment['avatar']);
			$id = !empty($id) ? ' id="' . $id . '"' : '';
			$class = !empty($class) ? ' class="' . $class . '"' : '';

			if (!empty($tag))
			{
				$object->avatar = '<' . $tag . $id . $class . '><img src="' . $this->host . '/image/' . $url . '"></' . $tag . '>' . "\r\n";
				$object->nick = '<' . $tag . $id . $class . '>' . $comment['nick'] . '</' . $tag . '>' . "\r\n";
				$object->text = '<' . $tag . $id . $class . '>' . $comment['text'] . '</' . $tag . '>' . "\r\n";
			}
			else
			{
				$object->avatar = '<img src="' . $this->host . '/image/' . $url . '">';
				$object->nick = $comment['nick'];
				$object->text = $comment['text'];
			}
		}
		else
		{
			$object->avatar = '';
			$object->nick = '';
			$object->text = '';
		}

		return $object;
	}

	function Page($controller)
	{
		$page = $this->F->CreateUrl($controller . '/');
		return $page;
	}

	function Url($type, $route = '')
	{
		$controller = !empty($route) ? $route : $this->F->GetController($_SERVER['REQUEST_URI']);
		$urls = $this->F->Urls($controller, $this->query);
		return $urls[$type];
	}

	function File($file)
	{
		$file = 'templates/' . $this->template . '/userinc/' . $file;

		if (file_exists($file) && 0 < filesize($file))
		{
			require($file);
		}
	}

	function String($file)
	{
		$string = $this->F->Random($file);
		return $string;
	}

	function LiveInternet()
	{
		$file = $this->F->path . 'liveinternet.php';

		if (file_exists($file) && 0 < filesize($file))
		{
			require($file);
		}
	}
}
?>